
#include "mp3encoder.h"
#include <iostream>
#include <string.h>
using namespace std;
MP3Encoder::MP3Encoder(WAVEFORMATEX* format)
{
    in_fmt=*format;
    lame_init(&gf);
    gf.silent=1;
    gf.padding=1;
    gf.VBR=0;
    gf.in_samplerate=format->nSamplesPerSec;
    gf.num_channels=format->nChannels;
    if(format->nChannels==1)
	gf.mode=3;
	else
	gf.mode=1;
//  int mode;                       /* 0,1,2,3 stereo,jstereo,dual channel,mono */

}
MP3Encoder::~MP3Encoder()
{
    Close(0,0,0);
}
int MP3Encoder::SetBitrate(int bitrate)
{
    cerr<<"Setting bit rate to "<<bitrate<<" "<<bitrate/125<<endl;
    gf.brate=bitrate/125;
    return 0;
}
int MP3Encoder::SetQuality(int quality)
{
    gf.quality=quality;
    return 0;
}
int MP3Encoder::GetFormatSize()
{
    return 18;
}
int MP3Encoder::GetFormat(char* extension, int size)
{
    if(size<18)return -1;
    WAVEFORMATEX wf;
    memcpy(&wf, &in_fmt, 18);
    wf.wFormatTag=0x55;
    wf.nAvgBytesPerSec=gf.brate*125;
    wf.nBlockAlign=1;
    wf.cbSize=0;
    memcpy(extension, &wf, 18);
    return 0;
}
int MP3Encoder::Start()
{
    lame_init_params(&gf);
    return 0;
}
int MP3Encoder::Convert(char* in_data, int in_size,
     char* out_data, int out_size,
    int* size_read, int* size_written)
{
#warning FIXME 8-bit?
    int result;
    if(in_fmt.nChannels==1)
	result=lame_encode_buffer(&gf, (short*)in_data, (short*)in_data,
         in_size, out_data, out_size);
	 else
	result=lame_encode_buffer_interleaved(&gf, (short*)in_data,
         in_size, out_data, out_size);
    if(result<0)result=0;
    if(size_read)*size_read=in_size;
    if(size_written)*size_written=result;
    return 0;
}
int MP3Encoder::Close(char* out_data, 
		int out_size, int* size_read)
{
    char buffer[7200];
    cerr<<"MP3EncodeR::Close()"<<endl;
    lame_encode_finish(&gf, buffer, 7200);
    return 0;
}
