/********************************************************

	Video decoder interface
	Copyright 2000 Eugene Kuznetsov  (divx@euro.ru)

*********************************************************/
#ifndef _VideoDecoder_H
#define _VideoDecoder_H

#include <videodecoder.h>
#include "VideoEncoder.h"
#include "Module.h"
/**
 * Win32 video decoder
 */
class VideoDecoder: public IVideoDecoder
{
public:
    VideoDecoder(const CodecInfo& info, const BITMAPINFOHEADER& format, int flip);
    ~VideoDecoder()
    {
	try
	{
    	    if(m_iState==2)Stop();
	    if(m_iState==1)Close();
	}
	catch(FatalError& error)
	{
	    cerr<<"~VideoDecoder(): ";
	    error.Print();
	} 
	if(m_outFrame)delete m_outFrame;   
	//for(int i=0; i<fields; i++)if(m_outFrame[i])delete m_outFrame[i];
    }	
    void Close();
    void Start();
    void Stop();
    BITMAPINFOHEADER& DestFmt(){return m_obh;}
    int DecodeFrame(char* src, int size, int is_keyframe);
    int SetDestFmt(int bits=24, int csp=0);
    CAPS GetCapabilities() const {return caps;}

    virtual const CodecInfo& GetCodecInfo() const {return record;}
    virtual void Restart();
    //    int SetDirection(int d)
//    {
//	m_obh.biHeight=d?m_bh.biHeight:(-m_bh.biHeight);	
//    }
//    int SetExtendedMode(int mode, int size);//mode=mmioFOURCC('Y', 'U', 'Y', '2')
    //size=12 (in bits)
//    int SetColorSpace(int csp);
private:
    VideoCodec* codec;
    const CodecInfo& record;
    int m_iState;
    static const int fields=20;
    CAPS caps;
    int field_num;
    int divx_trick;
};    
#endif
