#include "cfgvalues.h"
#include <string.h>
#include <xmms/configfile.h>
#include <SDL.h>

aviConfig avicfg;

#define I avicfg.

int cfgInit()
{
    I doSizePX=100000;
    I doSizePY=100000;
    I doAspect=0;        
    I doEnableResize=1;
    I doPosition=0;
    I doYUV=1;
    I doSoftYUV=0;    
    I doFullscreen=0;
    I doFullscreenAspect=1;
    I doFullscreenMode=0;
    I doSyncAudio=0;
    I doExtEffect=0;
    I typeAR=AR_MOST;
    I typeDS=DS_100_200;
    I typeLMB=LMB_FULLSCREEN;
    I typeFSR=FSR_LEAST;
    I fsW=640;
    I fsH=480;    
    I trackBar=TRK_NEVER;
    I doAutoHide=1;
    return 1;    
}

static gchar *cfgSection="avi-xmms";

#define GET(a) if (xmms_cfg_read_int(cfg,cfgSection,"avixmms_" #a,&tmp)) avicfg.a=tmp;
#define PUT(a) tmp=avicfg.a;xmms_cfg_write_int(cfg,cfgSection,"avixmms_" #a,tmp);

#define OPEN_CONFIG\
    gint tmp;\
    ConfigFile *cfg;\
    cfg=xmms_cfg_open_default_file();\
    if (!cfg) return 0;
#define WRITE_CONFIG xmms_cfg_write_default_file(cfg);
#define CLOSE_CONFIG xmms_cfg_free(cfg); 

int cfgRetrieve()
{
    OPEN_CONFIG
        GET(doSizePX)
        GET(doSizePY)
        GET(doAspect)
        GET(doEnableResize)
        GET(doPosition)
        GET(doYUV)
        GET(doSoftYUV)
        GET(doFullscreen)
        GET(doFullscreenMode)
        GET(doFullscreenAspect)
        GET(doSyncAudio)
        GET(doExtEffect)
        GET(typeAR)
        GET(typeDS)
        GET(typeLMB)        
        GET(typeFSR)
        GET(fsW)
        GET(fsH)                
        GET(storedX)        
        GET(storedY)
        GET(trackBar)
        GET(doAutoHide)
    CLOSE_CONFIG
}

int cfgStore()
{
    OPEN_CONFIG
        PUT(doSizePX)
        PUT(doSizePY)
        PUT(doAspect)
        PUT(doEnableResize)
        PUT(doPosition)
        PUT(doYUV)
        PUT(doSoftYUV)
        PUT(doFullscreen)
        PUT(doFullscreenMode)
        PUT(doFullscreenAspect)
        PUT(doSyncAudio)
        PUT(doExtEffect)
        PUT(typeAR)
        PUT(typeDS)
        PUT(typeLMB)
        PUT(typeFSR)                
        PUT(fsW)
        PUT(fsH)        
        PUT(storedX)
        PUT(storedY) 
        PUT(trackBar)
        PUT(doAutoHide)
    WRITE_CONFIG
    CLOSE_CONFIG
}
