
#define aviConfig_ID "XAVI101"

struct aviConfig
{
    char id[8]; // config file id
    
    int doSizePX,
        doSizePY; // user window size in percent to default and x1000
        
    int doAspect; // correct A/R (lock doSizePX and doSizePY)        
                
    int doEnableResize; // 0=window can't be resized manually
                        // 1=window can be resized
        
    int doPosition;     // 0=don't care window position
                        // 1=always center
                        // 2=store last position
                        
    int doYUV;          // 0=disable hardware YUV
                        // 1=enable hardware YUV
                        
    int doSoftYUV;      // 0=disable software YUV
                        // 1=enable software YUV
                        
    int doFullscreen;   // 0=windowed mode
                        // 1=fullscreen

    int doFullscreenMode;   // 0=use desktop res
                            // 1=switch mode

                        
    int doFullscreenAspect; // 0=disable aspect ratio correction in fs
                            // 1=enable aspect ratio correction in fs
                
    int doSyncAudio; // resync audio. (*1000)

    int doExtEffect;    // 0=ext effect disable
                        // 1=ext effect enable1
                        // 2=ext effect enable2
                        // 3=ext effect enable3
                        // ...
        
#define AR_MOST      0  // use the most changed dimension to control A/R
#define AR_AVERAGE   1  // use average of dimensions
#define AR_WIDTH     2  // use width only
#define AR_HEIGHT    3  // use height only
    int typeAR; 
                    
    
#define DS_100_200   0  // toggle between 100/200 %
#define DS_50_100    1  // toggle between 50/100 %
#define DS_CURRENTSZ 2  // use current size for DS
#define DS_DISABLE   3  // disable doublesizing
    int typeDS;

#define LMB_DISABLE    0 // disable left mouse button
#define LMB_ALWAYS     1 // enable always, toggle pause/play
#define LMB_FULLSCREEN 2 // enable fullscreen only, toggle pause/play
    int typeLMB;

#define FSR_DESKTOP    0 // use desktop resolution for fullscreen    
#define FSR_LEAST      1 // use least possible resolution for fullscreen    
#define FSR_SPECIFY    2 // specified by fsW and fsH
    int typeFSR;        
        
    int fsW,fsH;
    
    int storedX,storedY;
    
#define TRK_NEVER      0 // Never show trackbar    
#define TRK_FULLSCREEN 1 // Fullscreen only
#define TRK_ALWAYS     2 // Always
    int trackBar;        
    
    int doAutoHide;
};

extern aviConfig avicfg;

int cfgInit();
int cfgStore();
int cfgRetrieve();
