#include <SDL.h>
#include <xmms/xmmsctrl.h>
#include "cfgvalues.h"
#include "caviplay.h"

extern "C" {
gint ctrlsocket_get_session_id(void); /* FIXME */
};

extern cPlayer *current;
extern int showConfig();
extern int needResize;
extern int toggle_dsize();

#define REFRESH if (!needResize) needResize=1;            
#define sid ctrlsocket_get_session_id()
#define dd event.key.keysym

int keyHandler(const SDL_Event &event)
{
    int i;
    switch (dd.sym)
    {
        case SDLK_z:
            xmms_remote_playlist_prev(sid);
            break;
        case SDLK_x:
            xmms_remote_play(sid);
            break;
        case SDLK_c:
            xmms_remote_pause(sid);
            break;
        case SDLK_v:
            xmms_remote_stop(sid);
            break;
        case SDLK_b:
            xmms_remote_playlist_next(sid);
            break;
        case SDLK_PAGEUP:
            xmms_remote_playlist_next(sid);
            break;
        case SDLK_PAGEDOWN:
            xmms_remote_playlist_prev(sid);
            break;
        case SDLK_RETURN:
            if (xmms_remote_is_paused(sid))         
              xmms_remote_pause(sid);else
            if (!avicfg.doFullscreen)
            {
                avicfg.doFullscreen=1;
                REFRESH
            }else
            {
                avicfg.doFullscreen=0;
                REFRESH
            }
            break;
        case SDLK_ESCAPE:    
            if (avicfg.doFullscreen)
            {
                avicfg.doFullscreen=0;
                REFRESH
            }
            if (!xmms_remote_is_paused(sid)) 
              xmms_remote_pause(sid);              
            else
              xmms_remote_stop(sid);
            break;
//        case SDLK_TAB:
//            xmms_remote_set_main_volume(sid, vol);
//            break;
        case SDLK_p:
            if (avicfg.doFullscreen)
            {            
                avicfg.doFullscreen=0;
                REFRESH
                if (!xmms_remote_is_paused(sid)) 
                  xmms_remote_pause(sid);                
            }
            showConfig();
            break;
        case SDLK_d:
            if (avicfg.doFullscreen)
            {
                avicfg.doFullscreen=0;
                REFRESH
            }else
            {
                toggle_dsize();
            }
            break;
        case SDLK_PAUSE:
        case SDLK_SPACE:
            xmms_remote_pause(sid);
            break;
        case SDLK_RIGHT:
        {
            gint tt=xmms_remote_get_output_time(sid)+5000;
            xmms_remote_jump_to_time(sid, tt);
            break;
        }
        case SDLK_LEFT:
        {
            gint tt=xmms_remote_get_output_time(sid)-5000;
            if (tt<0) tt=0;
            xmms_remote_jump_to_time(sid, tt);
            break;
        }
        case SDLK_UP:
            i = xmms_remote_get_main_volume(sid);
            i += 5;
            if (i > 100)
                i = 100;
            xmms_remote_set_main_volume(sid, i);
            break;
        case SDLK_DOWN:
            i = xmms_remote_get_main_volume(sid);
            i -= 5;
            if (i < 0)
                i = 0;
            xmms_remote_set_main_volume(sid, i);
            break;
    };
    return 1;
}
