#include <stdio.h>
#include "zoomer.h"

static int theBPP;
static int w1,h1;
static int w2,h2;
static long *addrX=NULL,*addrY=NULL;

int buildZoomer(int _w1,int _h1,int _w2,int _h2,int bpp)
{
    if (_w1&&_h1&&_w2&&_h2&&((bpp==8)||(bpp==15)||(bpp==16)||(bpp==24)||(bpp==32)))
    {
        w1=_w1;h1=_h1;w2=_w2;h2=_h2;
        theBPP = (bpp==8)?1:
                 (bpp==15)?2:
                 (bpp==16)?2:
                 (bpp==24)?3:
                 (bpp==32)?4:0;                 
        
        if (addrX) delete[] addrX;
        if (addrY) delete[] addrY;
        addrX=new long[w2+16];
        addrY=new long[h2+16];
        for(int t=0;t<w2;t++) addrX[t]=(t*w1/w2);
        for(int t=0;t<h2;t++) addrY[t]=(t*h1/h2)*w1;
        
        return 1;
    }else 
      return 0;
}

/////////// THIS IS A DRAFT UNOPTIMIZED VERSION OF ZOOMER ///////////////

#define DEFINE_ZOOM(name,type)\
inline int name(register type *_src, register type *dest)\
{\
    for(register int y=0;y<h2;y++)\
    {\
        register type *row=_src+addrY[y];\
        for(register int x=0;x<w2;x++)\
          *(dest++)=row[addrX[x]];\
    }\
}
//////////////////////////////////////////////////////////////////////

#pragma pack (1)
typedef 
struct s_tribyte
{
    char b1,b2,b3;
} tribyte_t;

DEFINE_ZOOM(reZoom1,char)

DEFINE_ZOOM(reZoom2,short)

DEFINE_ZOOM(reZoom3,tribyte_t)
                             
DEFINE_ZOOM(reZoom4,int)

int reZoom(void *src,void *dest)
{
    return 
           (theBPP==2)?reZoom2((short *)src,(short *)dest):
           (theBPP==4)?reZoom4((int *)src,  (int *)dest):
           (theBPP==3)?reZoom3((tribyte_t *)src, (tribyte_t *)dest):           
           (theBPP==1)?reZoom1((char *)src, (char *)dest):                                 
           0;    
}
